#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <libgnomevfs/gnome-vfs-mime-handlers.h>
#include <teo.h>

/* ************************************************************************* */
typedef enum {
  TI_PIXEL_SIGNED,
  TI_PIXEL_UNSIGNED,
  TI_PIXEL_FLOAT
} TeoeyesPixelType;

/* ************************************************************************* */
typedef enum {
  GNOME_VFS_FILE_LOCAL,
  GNOME_VFS_FILE_NETWORK,
  GNOME_VFS_FILE_MEMORY
} GnomeVFSFileLocation;

/* ************************************************************************* */
typedef struct _GdkPixbufColorModifier {
  gint	gamma;
  gint	brightness;
  gint	contrast;
} GdkPixbufColorModifier;

typedef struct _GdkPixbufModifierMap {
  guchar	rmap[256];
  guchar	gmap[256];
  guchar	bmap[256];
} GdkPixbufModifierMap;

typedef struct _GdkPixbufModifier {
  GdkPixbufColorModifier	mod;
  GdkPixbufColorModifier	rmod;
  GdkPixbufColorModifier	gmod;
  GdkPixbufColorModifier	bmod;  
  GdkPixbufModifierMap		*map;
} GdkPixbufModifier;

/* TEImage¤ *********************************************************** */
typedef struct _TEImage {
  /* Υץѥƥ */
  gchar			*uri;                                  /* ե̾ */
  gint			xoffset;                              /* Xեå */
  gint			yoffset;                              /* Yեå */
  gint			width;                                   /*  */
  gint			height;                                /* ι⤵ */
  gint			nframes;                               /* ե졼 */
  gint			nchannels;                             /* ͥ */
  guchar		type;                                  /* ͤη */
  guchar		bit;                                       /* ǥץ */
  GnomeVFSFileLocation	location;                  /* եΥ */
  gboolean		has_alpha;               /* ץ졼󤬤뤫ɤ */

  /* ǡ */
  GdkPixbuf		*pixbuf;                    /* GdkPixbufǡ */
  GdkPixbufModifier 	*mod;                                /* ǡ */
  GList			*pixbuf_list;                    /* ǡꥹ */
  GdkPixmap		*pixmap;
  GList			*pixmap_list;
  
  /* ѥ᡼ */
  gint			frame;                       /* ɽΥե졼ֹ */
  gint			channel;                     /* ɽΥֹͥ */
  gdouble		min;
  gdouble		max;
  
  /* TEOΤѿ */
  gpointer		fp;                    /* եݥ (for TEO) */
  gpointer		original_list;     /* ꥸʥǡ (for TEO) */

  /*  */
  TeoeyesImageModule	*loader;                               /*  */
  
  /* ɥѥǡ */
  GdkPixbuf		*backup;                       /* Хååץǡ */

  gboolean		user_data[2];
} TEImage;

